#include	<math.h>
#include	<stdlib.h>
#include	<stdio.h>
#include	<unistd.h>
#include	<yz/window.h>
#include	"window_data.h"

window_t	*yzPostScriptWindow(char	*job, int	width, int	height, int	fd)
{
	char	prologue[] =	"/Times-Roman@0 findfont 12 scalefont setfont\n";
	char	offset[256];
	float	scale = 1.0;

	window_t	*w;
	window_data	*wd;

	w = malloc(sizeof(window_t));
	w->wseq = 0;
	w->res1 = 0;
	w->width = width;
	w->height = height;
	w->pen = (pen_t*)malloc(sizeof(pen_t));
	w->pen->color.r = w->pen->color.g = w->pen->color.b = 0;
	w->pen->size = 1;
	w->font = 0;
	w->origin_x = w->origin_y = 0;
	wd = malloc(sizeof(window_data));
	w->impl_data = wd;

	wd->fd = fd;
	wd->cs.a = 0;
	wd->cs.n = 0;
	wd->cs.r = 0;
	wd->os.a = 0;
	wd->os.n = 0;
	wd->os.p = 0;
	wd->fnt = 0;
	wd->buffer_mode = YZ_BUFFER_FRONT;

	// set up YZ coordinate system
	write(wd->fd, prologue, strlen(prologue));

	sprintf(offset, "20 820 translate\n"
					"1 -1 scale\n");
	write(wd->fd, offset, strlen(offset));
	wd->is_postscript = 1;

	return w;
}

void	transform_point(int	*x, int	*y);
int		yz_fd;
FILE	*ps_f;

int	yzPostScriptSetLandscape()
{
	fprintf(ps_f, "-90 rotate\n" "-800 0 translate\n");
	return 0;
}

int	yzPostScriptSetScale(float	scale)
{
	fprintf(ps_f, "%f %f scale\n", scale, scale);
	return 0;
}

yzPostScriptEndPage()
{
	fprintf(ps_f, "showpage\n");
	fflush(ps_f);
}

yzpsLine2i2i(int	x1, int	y1, int	x2, int	y2)
{
	transform_point(&x1, &y1);
	transform_point(&x2, &y2);

	fprintf(ps_f, "newpath %d %d moveto %d %d lineto stroke\n", x1, y1, x2, y2);
	return 0;
}

yzpsRect2i2i(int	x1, int	y1, int	x2, int	y2)
{
	transform_point(&x1, &y1);
	transform_point(&x2, &y2);

	fprintf(ps_f, "newpath %d %d moveto %d %d lineto %d %d lineto "
					"%d %d lineto closepath stroke\n", x1, y1, x2, y1, x2, y2, x1, y2);
	return 0;
}

yzpsCircle3i(int	x, int	y, int	r)
{
	int		i, st;
	float	t;

	transform_point(&x, &y);
	if(r<20)st = 15;
	else st = 100;
	fprintf(ps_f, "newpath %d %d moveto\n", x+r, y);
	for(i=1;i<=st;i++)
	{
		t = i * M_PI * 2 / st;
		fprintf(ps_f, " %.1f %.1f lineto\n", x+r*cos(t), y+r*sin(t));
	}
	fprintf(ps_f, "closepath stroke\n");
}

yzpsPenColor3i(int	r, int	g, int	b)
{
	fprintf(ps_f, "%.5f %.5f %.5f setrgbcolor\n", ((float)r)/65535, ((float)g)/65535, ((float)b)/65535);
	return 0;
}

yzpsText2i1p1i(int	x, int	y, char	*str, int	len)
{
	transform_point(&x, &y);

	fprintf(ps_f, "%d %d moveto 1 -1 scale (%.*s) show 1 -1 scale\n", x, y, len, str);
	return 0;
}

int	non_window_string_length(char	*ptr, int	length);

int	yzpsStringSize(char	*str, int	len)
{
	return non_window_string_length(str, len);
}

int	yzpsDefaultLineHeight()
{
	return non_window_default_line_height();
}
